<template>
  <div style="width: 100%" class="upload-file">
    <el-upload
        :action="uploadFileUrl + '?prePath=' + prePath"
        :before-upload="handleBeforeUpload"
        :file-list="fileList"
        :limit="limit"
        :on-error="handleUploadError"
        :on-exceed="handleExceed"
        :on-success="handleUploadSuccess"
        :show-file-list="false"
        :headers="headers"
        class="upload-file-uploader"
        ref="upload"
    >
      <!-- 上传按钮 -->
      <el-button size="mini" type="primary">选取文件</el-button>

      <!-- 上传提示 -->
      <div class="el-upload__tip" slot="tip" v-if="showTip">
        请上传
        <template v-if="fileSize">
          大小不超过 <b style="color: #f56c6c">{{ fileSize }}MB</b>
        </template>
        <template v-if="fileType">
          格式为 <b style="color: #f56c6c">{{ fileType.join("/") }}</b>
        </template>
        的文件
      </div>
    </el-upload>

    <!-- 文件列表 -->
    <transition-group
        style="width: 100%"
        class="upload-file-list el-upload-list el-upload-list--text"
        name="el-fade-in-linear"
        tag="ul"
    >
      <li
          :key="file.uid"
          class="el-upload-list__item ele-upload-list__item-content"
          v-for="(file, index) in fileList"
      >
        <el-link :href="file.url" :underline="false" target="_blank">
          <span class="el-icon-document" style="font-size: 12px">
            {{ getFileName(file.name) }}
          </span>
        </el-link>
        <div class="ele-upload-list__item-content-action">
          <el-link
              :underline="false"
              style="font-size: 12px"
              @click="handleDelete(index)"
              type="danger"
          >删除
          </el-link
          >
        </div>
      </li>
    </transition-group>
  </div>
</template>

<script>

export default {
  props: {
    // 值
    value: [String, Object, Array],
    // 大小限制(MB)
    fileSize: {
      type: Number,
      default: 50,
    },
    // 数量限制
    limit: {
      type: Number,
      default: 5,
    },
    // 文件类型, 例如['png', 'jpg', 'jpeg']
    // default: () => ["doc", "xls", "pdf", "xml"],
    fileType: {
      type: Array,
      default: null,
    },
    // 是否显示提示
    isShowTip: {
      type: Boolean,
      default: true
    },
    //保存服务器路径前缀地址
    prePath: {
      type: String,
      default: '',
    },
    //默认文件名称
    fileName: {
      type: String,
      default: '',
    }
  },
  data() {
    return {
      number: 0,
      uploadList: [],
      uploadFileUrl: "/office/file/commonupload", // 上传的地址
      headers: {},
      fileList: [],
    };
  },

  watch: {
    value: {
      handler(val) {
        if (val&&val!=='') {
          this.showFileList();
        } else {
          this.fileList = [];
          return [];
        }
      }
    }
  },

  computed: {
    // 是否显示提示
    showTip() {
      return this.isShowTip && (this.fileType || this.fileSize);
    },
  },
  methods: {

    showFileList(){
      let temp = 1;
      // 首先将值转为数组
      const filePathlist =  this.value.split(',');
      // 然后将数组转为对象数组
      const fileNamelist =this.fileName.split(',');
      for (var i = 0; i < filePathlist.length; i++) {
        if(filePathlist[i]==='') continue
        let item = {}
        if (fileNamelist.length === filePathlist.length) {
          item.name = fileNamelist[i];
        } else {
          item.name = filePathlist[i];
        }
        item.url = filePathlist[i];
        item.uid = new Date().getTime() + temp++;
        this.fileList.push(item)
      }
    },


    // 上传前校检格式和大小
    handleBeforeUpload(file) {
      // 校检文件类型
      if (this.fileType) {
        let fileExtension = "";
        if (file.name.lastIndexOf(".") > -1) {
          fileExtension = file.name.slice(file.name.lastIndexOf(".") + 1);
        }
        const isTypeOk = this.fileType.some((type) => {
          if (file.type.indexOf(type) > -1) return true;
          if (fileExtension && fileExtension.indexOf(type) > -1) return true;
          return false;
        });
        if (!isTypeOk) {
          this.$message.error(`文件格式不正确, 请上传${this.fileType.join("/")}格式文件!`);
          return false;
        }
      }
      // 校检文件大小
      if (this.fileSize) {
        const isLt = file.size / 1024 / 1024 < this.fileSize;
        if (!isLt) {
          this.$message.error(`上传文件大小不能超过 ${this.fileSize} MB!`);
          return false;
        }
      }
      return true;
    },
    // 文件个数超出
    handleExceed() {
      this.$message.error(`只允许上传单个文件`);
    },
    // 上传失败
    handleUploadError(err) {
      this.$message.error("上传失败, 请重试");
    },
    // 上传成功回调
    handleUploadSuccess(res, file) {
      if (res.code === 1) {
        this.fileList.push({name: res.fileName, url: res.url, uid: new Date().getTime()});

        let newFileList = this.fileList.map(i => i.url);
        let newFileNameList = this.fileList.map(i => i.name);
        this.$emit("input", newFileList.join(","));
         this.$emit("getFileName", newFileNameList.join(","));
        this.fileList =[]
        this.$message.success("上传成功");
      } else {
        this.$message.error(res.msg);
      }
    },
    // 删除文件
    handleDelete(index) {
      //todo 删除文件
      this.fileList.splice(index, 1);
      let newFileList = this.fileList.map(i => i.url);
      let newFileNameList = this.fileList.map(i => i.name);
      this.$emit("input", newFileList.join(","));
      this.$emit("getFileName", newFileNameList.join(","));
      this.fileList =[]
     // this.$emit("input", '');
    },
    // 获取文件名称
    getFileName(name) {
      console.log(name);
      if (name.lastIndexOf("/") > -1) {
        return name.slice(name.lastIndexOf("/") + 1).toLowerCase();
      } else {
        return name;
      }
    }
  },
  created() {
    console.log("file create")
    this.showFileList();
    // this.fileList = this.list;
  },
};
</script>

<style scoped lang="scss">
.upload-file-uploader {
  margin-bottom: 5px;
}

.upload-file-list .el-upload-list__item {
  border: 1px solid #e4e7ed;
  line-height: 2;
  margin-bottom: 10px;
  position: relative;
}

.upload-file-list .ele-upload-list__item-content {
  display: flex;
  justify-content: space-between;
  align-items: center;
  color: inherit;
}

.ele-upload-list__item-content-action .el-link {
  margin-right: 5px;
}
</style>
